case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

# libelmme-tls.so my be loaded with program, which do not have
# linked with libelmme-mbox.so. On that case loading failed
# with unresolved symbols. Therefore we link libelmme-smtp.so
# with libelmme-mailer.so. If loading program is linked with
# libelmme-smtp.so, that do not cause that libelmme-mailer.so
# is linked twice on run time.
#
libxs="../../shlib/libelmme-mbox.so"

# If it is not possible to resolve mail program symbols from
# dynamic library, link libelmme-smtp.so with libelmme-base.so

if $test $d_dynamic_main = "$define" ; then
	   : 
else
	libxs="$libxs ../../shlib/libelmme-base.so"
fi



echo "Extracting shared_libs/tls/Makefile (with variable substitutions)"
$cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.21 2006/04/09 07:37:30 hurtta Exp $
#
#
#  Makefile for the ELM (ME+) mail program.
#
#  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
#
#
INSTLIB		= \$(ELM_ROOT)//$shlib/libelmme-tls.so$d_shared_rev
AR		=	$ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CP		=	$cp
RM              =       $rm -f
MV              =       $mv
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
TOUCH           =       $touch
CHMOD           =       $chmod
LIBXS           =       $libxs
REG             =       ../../bin/elmregister -M tls
!GROK!THIS!

A=
if $test "$soname_include_path" = y ; then
	A="$shlib/"
fi

cat >>Makefile <<SUBSTITUTE
SONAME          = ${soname_opt}${A}libelmme-tls.so$d_shared_rev
SUBSTITUTE

if $test "$tls_lib_dir" != ""; then
    $cat >>Makefile <<EOS
LIBDIRLIST      =  -L$tls_lib_dir $rpath_opt$tls_lib_dir
EOS
else
    cat >>Makefile <<'EOX'
LIBDIRLIST      =
EOX
fi

if $test "$tls_include_dir" != "" ; then
    $cat >>Makefile <<EOS
INCDIRLIST      = -I$tls_include_dir
EOS
else
    $cat >>Makefile <<'EOX'
INCDIRLIST      =
EOX

fi
$cat >>Makefile <<'!NO!SUBS!'
CFLAGS		=	-I$(INCLDIR) $(INCDIRLIST) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	../include
OBJS            =       pop.o tls.o imap.o

all:	Makefile libtls.a ../../shlib/libelmme-tls.so
install_s: all $(INSTLIB)

uninstall_s:
	$(REG) rm $(INSTLIB)

clean: 
	rm -f $(OBJS) ../../shlib/libelmme-tls.so libtls.a

.PRECIOUS: $(INCLDIR)/elmshared.h ../../hdrs/defs.h 

$(INCLDIR)/elmshared.h: ../../hdrs/defs.h ../../hdrs/patchlevel.h ../../hdrs/elmlib.h $(INCLDIR)/shared.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

../../hdrs/defs.h: ../../config.h ../../hdrs/sysdefs.h
		$(CHMOD) u+w $@
		$(TOUCH) $@

Makefile: Makefile.SH ../../config.sh config.res
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

../../config.sh config.res:
	@echo "You must run 'sh Configure'"
	exit 1

lint:		

tags:

clean:		

elmtls.h: $(INCLDIR)/elmshared.h ../../hdrs/ss_imp.h \
 ../../hdrs/connection_imp.h ../../hdrs/mbx_imp.h ../../hdrs/mboxlib.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

pop.o: elmtls.h
tls.o: elmtls.h ../../hdrs/save_opts.h ../../hdrs/rc_imp.h
imap.o: elmtls.h


libtls.a: $(OBJS)
	$(AR) r $@ $?
	$(RANLIB) $@

../../shlib/libelmme-tls.so: $(OBJS) $(LIBXS)
	$(CC) $(CCFLAGS) $(LIBDIRLIST) $(SONAME) -o $@ $(OBJS) \
 $(LIBXS) -lssl -lcrypto 

$(INSTLIB): ../../shlib/libelmme-tls.so
	$(REG) copy -m 444 $? $@

!NO!SUBS!
