/* $Id: def_block.h,v 1.4 2006/04/09 07:37:42 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.4 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI>
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#include "headers.h"
#include "mboxlib.h"
#include "mailerlib.h"
#include "me.h"

#define BLOCK_magic		0xED00

struct text_block {
    unsigned short        magic;     /* BLOCK_magic */

    struct text_block_type  *block_type;

    union {
	void                * dummy;
	struct fileblock    * fileblock;
	struct stringblock  * stringblock;
    } u;

    int quote;
};

typedef void tb_free_block P_((struct text_block *block));
typedef void tb_alloc_block P_((struct text_block *block));
typedef charset_t tb_get_charset_from_block P_((struct text_block *block));

/* idx == 0 is first line */
typedef struct string * get_line_from_block P_((struct text_block *block, int *idx, int *errors));

#define BLOCK_type_magic	0xED01

struct text_block_type {
    unsigned short        magic;     /* BLOCK_type_magic */

    tb_free_block              * tb_free_it;
    tb_alloc_block             * tb_alloc_it;
    tb_get_charset_from_block  * tb_get_charset_from_it;
    get_line_from_block        * get_line_from_it;
};

struct text_block * alloc_block P_((struct text_block_type *block_type));

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
