case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	ln ../../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting src/url/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.6 2006/06/25 10:41:05 hurtta Exp $
#  Makefile for the ELM mail program.
#
# Variables
#	Variables established by Configure
AR		=	$ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHMOD		=	$chmod
LINT		=	$lint
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
RM		= 	$rm -f
TOUCH		=	$touch
TAGS		=	ctags

!GROK!THIS!

cat >>Makefile <<'!NO!SUBS!'
#	Other general variables
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE) $(DEBUG) 
INCLDIR		=	../../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh

OBJ		=	url.o url_element.o url_path.o no_url.o \
 mailto.o http.o imap.o



all:			Makefile liburl.a

install_s:		Makefile liburl.a

uninstall_s:		

clean:
	$(RM) $(OBJ) liburl.a

Makefile: Makefile.SH ../../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

liburl.a:		$(OBJ)
			$(AR) r $@ $?
			$(RANLIB) $@

#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(INCLDIR)/defs.h $(INCLDIR)/headers.h def_url.h

$(INCLDIR)/defs.h:	$(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/headers.h:	$(INCLDIR)/defs.h $(INCLDIR)/mime.h $(INCLDIR)/me.h $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

def_url.h:		$(INCLDIR)/headers.h $(INCLDIR)/me.h \
 $(INCLDIR)/mailerlib.h $(INCLDIR)/mboxlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

#	Dependencies of C object files

url.o:	     def_url.h $(INCLDIR)/s_me.h
url_element.o:	     def_url.h $(INCLDIR)/s_me.h
url_path.o:	     def_url.h $(INCLDIR)/s_me.h
no_url.o:	     def_url.h 
http.o:		     def_url.h 
mailto.o:	     def_url.h $(INCLDIR)/s_me.h
imap.o:		     def_url.h $(INCLDIR)/s_me.h
!NO!SUBS!
