case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting utils/readmsg/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# @(#)$Id: Makefile.SH,v 1.6 2006/05/31 08:13:23 hurtta Exp $
#
#  Makefile for the Elm system utilities
#
# Modified by Kari Hurtta Kari Hurtta <hurtta+elm@posti.FMI.FI>
######################################################################
# Based on utils/Makefile.SH. That code was following copyright:
#
#         (C) Copyright 1986,1987, by Dave Taylor
#         (C) Copyright 1988-1992, USENET Community Trust
######################################################################
#
# Variables
#	Variables established by Configure
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHMOD		=	$chmod
CP		=	$cp
DEST		=	\$(ELM_ROOT)//$bin
ECHO		=	$echo
LFLAGS		=	$ldflags $dynamic_opt $xenlf
LIB		=	\$(ELM_ROOT)//$lib
LIB2		= 	$dlopen_lib $libs
LIB1		=	$cryptlib $dbm
LINT		=	$lint
LN		=	$ln
MV		=	$mv
OPTIMIZE	=	$optimize
RM		= 	$rm -f
TOUCH		=	$touch

!GROK!THIS!

if $test "X$rpath_ok" = XOK ; then

# Use -rpath for directories need by shared_libs 
# It is is possbile to also use -rpath-link on Linux and SunOS
# but it may require extra Configure test....

	 rlink=
	 for domake in $shared_list ; do
		dir=
		varname="\$${domake}_lib_dir"
		eval "dir=$varname"
		if $test "X$dir" != X ; then
			rlink="$rlink $rpath_opt$dir"
		fi
	 done

	 cat >>Makefile <<!GROK!THIS!
RPATH           =       $rpath_opt$shlib $rlink
!GROK!THIS!

else
	 cat >>Makefile <<!GROK!THIS!
RPATH           =       
!GROK!THIS!

fi

if $test "$make_sets_make" != "$define" ; then  

	cat >>Makefile <<!GROK!THIS!
MAKE		=	$make
!GROK!THIS!

fi

if $test "$d_shared" = "$define" ; then

cat >>Makefile <<'!NO!SUBS!'
SHLIST          = $(BIN)/readmsg-shared
!NO!SUBS!

else

cat >>Makefile <<'!NO!SUBS!'
SHLIST          =
!NO!SUBS!

fi


cat >>Makefile <<'!NO!SUBS!'
#	Other general variables
BIN		=	../../bin
LIBS		=	../../libs
SHLIB		=	../../shlib
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	../../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh
REG             =       ../../bin/elmregister
OBJS            =       readmsg.o fstate.o wrapper.o folder.o

# Standard targets
all:		Makefile $(BIN)/readmsg $(SHLIST)

install_s:	Makefile $(DEST) $(DEST)/readmsg

uninstall_s:	
		$(REG) rm $(DEST)/readmsg

Makefile: Makefile.SH ../../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

clean: 
	rm -f $(OBJS) $(BIN)/readmsg $(SHLIST)

lint:		

tags:

.PRECIOUS:		$(INCLDIR)/defs.h $(INCLDIR)/elm.h \
			$(INCLDIR)/headers.h def_readmsg.h


#	Dependencies of header files upon other header files they include
$(INCLDIR)/defs.h:	$(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/elmutil.h:	$(INCLDIR)/defs.h $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

def_readmsg.h:		$(INCLDIR)/defs.h $(INCLDIR)/mboxlib.h \
 $(INCLDIR)/elmlib.h $(INCLDIR)/melib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@


# Dependencies and rules
#	Dependencies and rules for compiling C programs

readmsg.o: def_readmsg.h $(INCLDIR)/s_readmsg.h $(INCLDIR)/readmsg.h
fstate.o:  def_readmsg.h
wrapper.o: def_readmsg.h
folder.o:  def_readmsg.h


$(BIN)/readmsg:		$(OBJS) $(LIBS)/libelmme-mime.a \
$(LIBS)/libelmme-base.a $(LIBS)/libelmme-misc.a $(LIBS)/libelmme-mbox.a
			$(CC) $(LFLAGS) -o $@ $(OBJS) \
 $(LIBS)/libelmme-mime.a $(LIBS)/libelmme-misc.a $(LIBS)/libelmme-mbox.a $(LIBS)/libelmme-base.a $(LIB1) $(LIB2)


$(LIBS)/libelmme-mime.a:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

$(LIBS)/libelmme-mbox.a:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

$(LIBS)/libelmme-base.a:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

$(LIBS)/libelmme-misc.a:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

!NO!SUBS!


if $test "$d_shared" = "$define" ; then

cat >>Makefile <<'!NO!SUBS!'

$(BIN)/readmsg-shared:		$(OBJS) $(SHLIB)/libelmme-base.so \
 $(SHLIB)/libelmme-mbox.so $(SHLIB)/libelmme-mime.so $(SHLIB)/libelmme-misc.so 
		$(CC) $(LFLAGS) -o $@ $(RPATH) $(OBJS) \
 $(SHLIB)/libelmme-mime.so  $(SHLIB)/libelmme-misc.so \
 $(SHLIB)/libelmme-mbox.so $(SHLIB)/libelmme-base.so  $(LIB1) $(LIB2)

$(DEST)/readmsg:	$(BIN)/readmsg-shared
			$(REG) copy -m 555 $? $@

$(SHLIB)/libelmme-base.so:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

$(SHLIB)/libelmme-mbox.so:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@
	
$(SHLIB)/libelmme-mime.so:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

$(SHLIB)/libelmme-misc.so:
	cd ../..; $(MAKE) $(MJ) $(MFLAGS) $@

!NO!SUBS!

else

cat >>Makefile <<'!NO!SUBS!'

$(DEST)/readmsg:	$(BIN)/readmsg
			$(REG) copy -m 555 $? $@

!NO!SUBS!

fi

